VERSION 5.00
Begin VB.UserControl RotatedBoundControl 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1425
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1530
   ScaleHeight     =   1425
   ScaleWidth      =   1530
End
Attribute VB_Name = "RotatedBoundControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Default property values.
Private Const m_def_Angle = 0
Private Const m_def_DataControlName = ""
Private Const m_def_DataFieldName = ""

' Property variables.
Private m_Font As Font
Private m_Angle As Single
Private m_DataControlName As String
Private WithEvents m_DataControl As Data
Attribute m_DataControl.VB_VarHelpID = -1
Private m_DataFieldName As String

Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal I As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Public Property Get DataFieldName() As String
    DataFieldName = m_DataFieldName
End Property
Public Property Let DataFieldName(ByVal New_DataFieldName As String)
    m_DataFieldName = New_DataFieldName
    PropertyChanged "DataFieldName"
End Property

' Draw the text at the correct angle.
Private Sub DrawValue(ByVal txt As String)
Const FW_BOLD = 700
Const FW_NORMAL = 400

Dim wgt As Long
Dim X As Single
Dim Y As Single

    ' Clear the control.
    Cls

    ' See whether the text should be bold.
    If m_Font.Bold Then
        wgt = FW_BOLD
    Else
        wgt = FW_NORMAL
    End If

    ' Estimate where the text should begin. My book
    ' "Visual Basic Graphics Programming" shows how to
    ' calculate this exactly but it's work so we won't
    ' do it here. For more information, go to:
    '
    '       http://www.vb-helper.com/vbgp.htm
    '
    ' This only works for 0 <= Angle <= 90.
    X = 0
    Y = Height - ScaleY(m_Font.Size, vbPoints, ScaleMode)

    ' Draw the text.
    DrawRotatedText txt, X, Y, m_Font.Name, _
        ScaleX(m_Font.Size, vbPoints, vbPixels), _
        wgt, Angle * 10, _
        m_Font.Italic, m_Font.Underline, _
        m_Font.Strikethrough
End Sub

Private Sub DrawRotatedText(ByVal txt As String, _
    ByVal X As Single, ByVal Y As Single, _
    ByVal font_name As String, ByVal Size As Long, _
    ByVal weight As Long, ByVal escapement As Long, _
    ByVal use_italic As Boolean, ByVal use_underline As Boolean, _
    ByVal use_strikethrough As Boolean)

Const CLIP_LH_ANGLES = 16   ' Needed for tilted fonts.
Const PI = 3.14159625
Const PI_180 = PI / 180#

Dim newfont As Long
Dim oldfont As Long

    newfont = CreateFont(Size, 0, _
        escapement, escapement, weight, _
        use_italic, use_underline, _
        use_strikethrough, 0, 0, _
        CLIP_LH_ANGLES, 0, 0, font_name)
    
    ' Select the new font.
    oldfont = SelectObject(hdc, newfont)
    
    ' Display the text.
    CurrentX = X
    CurrentY = Y
    Print txt

    ' Restore the original font.
    newfont = SelectObject(hdc, oldfont)
    
    ' Free font resources (important!)
    DeleteObject newfont
End Sub
Private Sub m_DataControl_Reposition()
    If m_DataFieldName <> "" Then
        DrawValue m_DataControl.Recordset.Fields(m_DataFieldName)
    End If
End Sub
' Initialize properties.
Private Sub UserControl_InitProperties()
    m_DataFieldName = m_def_DataFieldName
    m_DataControlName = m_def_DataControlName
    m_Angle = m_def_Angle
    Set m_Font = Ambient.Font
End Sub

' Load properties.
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_DataFieldName = PropBag.ReadProperty("DataFieldName", m_def_DataFieldName)
    DataControlName = PropBag.ReadProperty("DataControlName", m_def_DataControlName)
    m_Angle = PropBag.ReadProperty("Angle", m_def_Angle)
    Set m_Font = PropBag.ReadProperty("Font", Ambient.Font)
End Sub

' Save properties.
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "DataFieldName", m_DataFieldName, m_def_DataFieldName
    PropBag.WriteProperty "DataControlName", m_DataControlName, m_def_DataControlName
    PropBag.WriteProperty "Angle", m_Angle, m_def_Angle
    PropBag.WriteProperty "Font", m_Font, Ambient.Font
End Sub

Public Property Get DataControlName() As String
    DataControlName = m_DataControlName
End Property

Public Property Let DataControlName(ByVal New_DataControlName As String)
Dim ctl As Control

    m_DataControlName = New_DataControlName
    PropertyChanged "DataControlName"

    ' Find the control.
    For Each ctl In Extender.Parent.Controls
        If ctl.Name = m_DataControlName Then Exit For
    Next ctl
    If Not (ctl Is Nothing) Then Set m_DataControl = ctl
End Property

' Return the text's angle.
Public Property Get Angle() As Single
    Angle = m_Angle
End Property

' Set the text's angle.
Public Property Let Angle(ByVal New_Angle As Single)
    m_Angle = New_Angle
    PropertyChanged "Angle"
End Property
' Return the Font.
Public Property Get Font() As Font
    Set Font = m_Font
End Property

' Set the Font.
Public Property Set Font(ByVal New_Font As Font)
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set m_Font = New_Font
    PropertyChanged "Font"
End Property

